/* 
dz80_2 is registered Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2007 <Jan Panteltje>
email: panteltje@yahoo.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>

#define FP fprintf


#include "table.c"
#include "dz80dat.c"


FILE *f1, *f2, *f3, *fx;
unsigned int start,end,pc=0;
int z80flag,smcflag=0;
int pass=0;
int t[10];
char *rarg[]={"b","c","d","e","h","l","(hl)","a"};
char *ed40[]={
/*40*/"in b,(c)",
/*41*/"out (c),b",
/*42*/"sbc hl,bc",
/*43*/"ld (",
/*44*/"neg",
/*45*/"retn",
/*46*/"im 0",
/*47*/"ld i,a",
/*48*/"in c,(c)",
/*49*/"out (c),c",
/*4a*/"adc hl,bc",
/*4b*/"ld bc,(",
/*4c*/"00",
/*4d*/"reti",
/*4e*/"00",
/*4f*/"ld r,a",
};
char *ed50[]={
/*50*/"in d,(c)",
/*51*/"out (c),d",
/*52*/"sbc hl,de",
/*53*/"ld (",
/*54*/"00",
/*55*/"00",
/*56*/"im 1",
/*57*/"ld a,i",
/*58*/"in e,(c)",
/*59*/"out (c),e",
/*5a*/"adc hl,de",
/*5b*/"ld de,(",
/*5c*/"00",
/*5d*/"00",
/*5e*/"im 2",
/*5f*/"ld a,r",
};
char *ed60[]={
/*60*/"in h,(c)",
/*61*/"out (c),h",
/*62*/"sbc hl,hl",
/*63*/"00",
/*64*/"00",
/*65*/"00",
/*66*/"00",
/*67*/"rrd",
/*68*/"in l,(c)",
/*69*/"out (c),l",
/*6a*/"adc hl,hl",
/*6b*/"00",
/*6c*/"00",
/*6d*/"00",
/*6e*/"00",
/*6f*/"rld",
};
char *ed70[]={
/*70*/"00",
/*71*/"00",
/*72*/"sbc hl,sp",
/*73*/"ld (",
/*74*/"00",
/*75*/"00",
/*76*/"00",
/*77*/"00",
/*78*/"in a,(c)",
/*79*/"out (c),a",
/*7a*/"adc hl,sp",
/*7b*/"ld sp,(",
/*7c*/"00",
/*7d*/"00",
/*7e*/"00",
/*7f*/"00",
};
char *eda0[]={
/*a0*/"ldi",
/*a1*/"cpi",
/*a2*/"ini",
/*a3*/"outi",
/*a4*/"00",
/*a5*/"00",
/*a6*/"00",
/*a7*/"00",
/*a8*/"ldd",
/*a9*/"cpd",
/*aa*/"ind",
/*ab*/"outd",
/*ac*/"00",
/*ad*/"00",
/*ae*/"00",
/*af*/"00",
};
char *edb0[]={
/*b0*/"ldir",
/*b1*/"cpir",
/*b2*/"inir",
/*b3*/"otir",
/*b4*/"00",
/*b5*/"00",
/*b6*/"00",
/*b7*/"00",
/*b8*/"lddr",
/*b9*/"cpdr",
/*ba*/"indr",
/*bb*/"otdr",
/*bc*/"00",
/*bd*/"00",
/*be*/"00",
/*bf*/"00",
};
int aflag,tflag,sflag,zflag,rflag,lflag,oflag=0;
char tg[20],tz[20],ts[20];

int shiftin()
{
t[0]=t[1];t[1]=t[2];t[2]=t[3];t[3]=t[4];t[4]=t[5];t[5]=getc(f1);
return(t[5]);
}

int ckrange(m,l,str,p)/*mode,lflag,bstr,pass*/
int m,l,p;
char str[];
{
unsigned int a;
int v = 0; // -Wall
char cstr[20];
if(m==1)v=t[1]+256*t[2];
if(m==2)v=t[2]+256*t[3];
if((pass==1) || (pass==2))
	{
	sprintf(str,"0%04xh",v);
	return 0;
	}
if(pass==3)
	{
	if((v<start) || (v>end))/*not in code area*/
		{
		sprintf(str,"0%04xh",v);
		return 0;
		}
	sprintf(cstr,"%04x",v);
	switch(getmark(cstr))
		{
		case 1:	/*present in table, instruction address*/
			if(l)sprintf(str,"l%04xh",v);
			else sprintf(str,"0%04xh",v);
			break;
		case 0:	/*present in table, but not an instr. address*/
			a=v-1;/*address is argument -1*/
			while(1)
				{
				sprintf(cstr,"%04x",a);
				if(getmark(cstr) == 1)/*valid instr. address*/
					{
					if(l)sprintf(str,"l%04xh+%d",a,v-a);
					else sprintf(str,"0%04xh+%d",a,v-a);
					smcflag=1;
					break;
					}
				a--;
				if( (v-a) > 5)/*max instr. length*/
					{
					sprintf(str,"0%04xh",v);
					break;
					}
				}/*end while counting back*/
			break;
		case -1:	/*not in table error condition*/
			sprintf(str,"0%04xh",v);
			break;
		}/*end switch getmark(cstr)*/
	}/*end if pass == 3*/

return 1;
}


int diz80()
{
char stri[80];
char stro[80];
int a;
char bstr[20];
char rstr[20];

if(t[0]==-1)return(0);/*end of file*/

FP(fx,"\t");/*before all instructions*/

if(t[0] == 0xcb)
	{
	a=t[1];
	if(a < 8)				FP(fx,"rlc ");
	else if((a >= 0x08) && (a < 0x10))	FP(fx,"rrc ");
	else if((a >= 0x10) && (a < 0x18))	FP(fx,"rl ");
	else if((a >= 0x18) && (a < 0x20))	FP(fx,"rr ");
	else if((a >= 0x20) && (a < 0x28))	FP(fx,"sla ");
	else if((a >= 0x28) && (a < 0x30))	FP(fx,"sra ");
	else if((a >= 0x38) && (a < 0x40))	FP(fx,"srl ");
	else if((a >= 0x40) && (a < 0x80))	FP(fx,"bit %d,",(a-0x40)/8);
	else if((a >= 0x80) && (a < 0xc0))	FP(fx,"res %d,",(a-0x80)/8);
	else if(a >= 0xc0)			FP(fx,"set %d,",(a-0xc0)/8);
	FP(fx,"%s",rarg[a%8]);
	z80flag=1;
	return(2);
	}
else if(t[0] == 0xed)
	{
	a=t[1];
if((a>=0x40)&&(a<0x50)&&(ed40[a-0x40][0]!='0'))FP(fx,"%s",ed40[a-0x40]);
else if((a>=0x50)&&(a<0x60)&&(ed50[a-0x50][0]!='0'))FP(fx,"%s",ed50[a-0x50]);
else if((a>=0x60)&&(a<0x70)&&(ed60[a-0x60][0]!='0'))FP(fx,"%s",ed60[a-0x60]);
else if((a>=0x70)&&(a<0x80)&&(ed70[a-0x70][0]!='0'))FP(fx,"%s",ed70[a-0x70]);
else if((a>=0xa0)&&(a<0xb0)&&(eda0[a-0xa0][0]!='0'))FP(fx,"%s",eda0[a-0xa0]);
else if((a>=0xb0)&&(a<0xc0)&&(edb0[a-0xb0][0]!='0'))FP(fx,"%s",edb0[a-0xb0]);
	else
		{
		FP(fx,"defb 0edh");
		FP(fx,";next byte illegal after ed");
		return(1);
		}
	z80flag=1;
	ckrange(2,lflag,bstr,pass);
/*if arg not in prog range it is a constant*/
	if(a == 0x43)
		{
		FP(fx,"%s),bc",bstr);
		return(4);
		}
	else if(a == 0x53)
		{
		FP(fx,"%s),de",bstr);
		return(4);
		}
	else if(a == 0x73)
		{
		FP(fx,"%s),sp",bstr);
		return(4);
		}
	else if((a == 0x4b) || (a == 0x5b) || (a == 0x7b))
		{
		FP(fx,"%s)",bstr);
		return(4);
		}
	return(2);
	}
else if((t[0] == 0xdd) || (t[0] == 0xfd))
	{
	if(t[0]==0xfd)strcpy(stri,"iy");
	else strcpy(stri,"ix");
	z80flag=1;
	ckrange(2,lflag,bstr,pass);
	switch(t[1])
		{
		case 0x09:
			FP(fx,"add %s,bc",stri);
			return(2);
			break;
		case 0x19:
			FP(fx,"add %s,de",stri);
			return(2);
			break;
		case 0x21:
			FP(fx,"ld %s,%s",stri,bstr);
			return(4);
			break;
		case 0x22:
			FP(fx,"ld (%s),%s",bstr,stri);
			return(4);
			break;
		case 0x23:
			FP(fx,"inc %s",stri);
			return(2);
			break;
		case 0x29:
			FP(fx,"add %s,%s",stri,stri);
			return(2);
			break;
		case 0x2a:
			FP(fx,"ld %s,(%s)",stri,bstr);
			return(4);
			break;
		case 0x2b:
			FP(fx,"dec %s",stri);
			return(2);
			break;
		case 0x39:
			FP(fx,"add %s,sp",stri);
			return(2);
			break;
		case 0xe1:
			FP(fx,"pop %s",stri);
			return(2);
			break;
		case 0xe3:
			FP(fx,"ex (sp),%s",stri);
			return(2);
			break;
		case 0xe5:
			FP(fx,"push %s",stri);
			return(2);
			break;
		case 0xe9:
			FP(fx,"jp (%s)",stri);
			return(2);
			break;
		case 0xf9:
			FP(fx,"ld sp,%s",stri);
			return(2);
			break;
		} /* end switch */
	/* now it must be an instruction of type (ix+dd) or (iy+dd) */

	if(t[2] < 128) sprintf(stro,"(%s+0%02xh)",stri,t[2]); /* stro is: (ix+dd) or (iy+dd) */
	else sprintf(stro,"(%s-0%02xh)",stri,256 - t[2]); 

	if(t[1]==0xcb)
		{
		switch(t[3])
			{
			case 0x06:
				FP(fx,"rlc ");
				break;
			case 0x0e:
				FP(fx,"rrc ");
				break;
			case 0x16:
				FP(fx,"rl ");
				break;
			case 0x1e:
				FP(fx,"rr ");
				break;
			case 0x26:
				FP(fx,"sla ");
				break;
			case 0x2e:
				FP(fx,"sra ");
				break;
			case 0x3e:
				FP(fx,"srl ");
				break;
			case 0x46:
				FP(fx,"bit 0,");
				break;
			case 0x4e:
				FP(fx,"bit 1,");
				break;
			case 0x56:
				FP(fx,"bit 2,");
				break;
			case 0x5e:
				FP(fx,"bit 3,");
				break;
			case 0x66:
				FP(fx,"bit 4,");
				break;
			case 0x6e:
				FP(fx,"bit 5,");
				break;
			case 0x76:
				FP(fx,"bit 6,");
				break;
			case 0x7e:
				FP(fx,"bit 7,");
				break;
			case 0x86:
				FP(fx,"res 0,");
				break;
			case 0x8e:
				FP(fx,"res 1,");
				break;
			case 0x96:
				FP(fx,"res 2,");
				break;
			case 0x9e:
				FP(fx,"res 3,");
				break;
			case 0xa6:
				FP(fx,"res 4,");
				break;
			case 0xae:
				FP(fx,"res 5,");
				break;
			case 0xb6:
				FP(fx,"res 6,");
				break;
			case 0xbe:
				FP(fx,"res 7,");
				break;
			case 0xc6:
				FP(fx,"set 0,");
				break;
			case 0xce:
				FP(fx,"set 1,");
				break;
			case 0xd6:
				FP(fx,"set 2,");
				break;
			case 0xde:
				FP(fx,"set 3,");
				break;
			case 0xe6:
				FP(fx,"set 4,");
				break;
			case 0xee:
				FP(fx,"set 5,");
				break;
			case 0xf6:
				FP(fx,"set 6,");
				break;
			case 0xfe:
				FP(fx,"set 7,");
				break;
			default:
		FP(fx,"defb 0%02xh,0%02xh,0%02xh,0%02xh\t;illegal sequence"\
			,t[0],t[1],t[2],t[3]);
				return(4);
			}/*end switch t[3]*/
		FP(fx,"%s",stro);
		return(4);
		}/*end dd cb or fd cb*/
	else switch(t[1])
		{
		case 0x34:
			FP(fx,"inc %s",stro);
			break;
		case 0x35:
			FP(fx,"dec %s",stro);
			break;
		case 0x36:
			FP(fx,"ld %s,0%02xh",stro,t[3]);
			return(4);
			break;
		case 0x46:
			FP(fx,"ld b,%s",stro);
			break;
		case 0x4e:
			FP(fx,"ld c,%s",stro);
			break;
		case 0x56:
			FP(fx,"ld d,%s",stro);
			break;
		case 0x5e:
			FP(fx,"ld e,%s",stro);
			break;
		case 0x66:
			FP(fx,"ld h,%s",stro);
			break;
		case 0x6e:
			FP(fx,"ld l,%s",stro);
			break;
		case 0x70:
			FP(fx,"ld %s,b",stro);
			break;
		case 0x71:
			FP(fx,"ld %s,c",stro);
			break;
		case 0x72:
			FP(fx,"ld %s,d",stro);
			break;
		case 0x73:
			FP(fx,"ld %s,e",stro);
			break;
		case 0x74:
			FP(fx,"ld %s,h",stro);
			break;
		case 0x75:
			FP(fx,"ld %s,l",stro);
			break;
		case 0x77:
			FP(fx,"ld %s,a",stro);
			break;
		case 0x7e:
			FP(fx,"ld a,%s",stro);
			break;
		case 0x86:
			FP(fx,"add a,%s",stro);
			break;
		case 0x8e:
			FP(fx,"adc a,%s",stro);
			break;
		case 0x96:
			FP(fx,"sub %s",stro);
			break;
		case 0x9e:
			FP(fx,"sbc a,%s",stro);
			break;
		case 0xa6:
			FP(fx,"and %s",stro);
			break;
		case 0xae:
			FP(fx,"xor %s",stro);
			break;
		case 0xb6:
			FP(fx,"or %s",stro);
			break;
		case 0xbe:
			FP(fx,"cp %s",stro);
			break;
		default:
			FP(fx,"defb 0%02xh,0%02xh,0%02xh\t;illegal sequence"\
			,t[0],t[1],t[2]);
			return(3);
		}/*end switch t[1]*/
	return(3);
	}/*end 0xdd and 0xfd group*/
FP(fx,"%s",comtab[t[0]].com1);
ckrange(1,lflag,bstr,pass);
switch(comtab[t[0]].type)
	{
	case 0:
		FP(fx,"\t");
		break;
	case 1:
		FP(fx,"0%02xh",t[1]);
		break;
	case 2:
		FP(fx,"%s",bstr);
		break;
	case 3:
		if(comtab[t[0]].bytes == 2)
			{
			/*jr and djnz instr. are 2 bytes type 3*/
			if(lflag)
				{
				if(t[1]<128)sprintf(rstr,"%04x",pc+2+t[1]);
				else sprintf(rstr,"%04x",pc+2+t[1]-256);
				if(getmark(rstr)==1)/*present in table, instr. address*/
					{
					FP(fx,"l%sh",rstr);
					}
				else
					{
					/* for old Zilog za.com */
//					if(t[1]<128)FP(fx,"%d",t[1]+2);
//					else FP(fx,"%d",t[1]+2-256);

					/*
					for zasm - z80 assembler 3.0.17 (c) 1994-2006 Günter Woigk.
					also for z80asm http://savannah.nongnu.org/projects/z80asm/
					 */
					if(t[1]<128)FP(fx,"$+%d",t[1]+2);
					else FP(fx,"$%d",t[1]+2-256);
					}
				}
			if(!lflag)
				{
				/* for old Zilog za.com */
//				if(t[1]<128)FP(fx,"%d",t[1]+2);
//				else FP(fx,"%d",t[1]+2-256);/*sign bit*/

				/*
				for zasm - z80 assembler 3.0.17 (c) 1994-2006 Günter Woigk.
				also for z80asm http://savannah.nongnu.org/projects/z80asm/
				 */
				if(t[1]<128)FP(fx,"$+%d",t[1]+2);
				else FP(fx,"$%d",t[1]+2-256);/*sign bit*/
				}
			}
		else FP(fx,"0%02xh",t[1]);/*not jr*/
		break;
	case 11:
		FP(fx,"0%02xh%s",t[1],comtab[t[0]].com2);
		break;
	case 12:
		FP(fx,"%s%s",bstr,comtab[t[0]].com2);
		break;
	}
a=comtab[t[0]].bytes;
if(comtab[t[0]].proc==1)z80flag=1;
return(a);
}


int main(argc,argv)
char *argv[];
int argc;
{
char astr[20];
int i,pci;
fx = stdout;/*select terminal*/
FP(fx,"\nPanteltje (c) Z80 assembly language generating disassembler  3.1 \
 1994-2008\n\n");
if((argc<2)||(argc>7))
	{
	FP(fx,"Usage: dz80 infile.ext [-a] [-l] [-o] [-r] [-s] [-t] [-z]\n");
	FP(fx,"-a for addresses only in zsm file.\n");
	FP(fx,"-l for labels.\n");
	FP(fx,"-o for other org then 100h (256d).\n");
	FP(fx,"-r for reduced symbol table (memory size).\n");
	FP(fx,"-s for symfile.\n");
	FP(fx,"-t for source print in zsm file.\n");
	FP(fx,"-z for zsmfile.\n");
	FP(fx, "Examples:\n");
	FP(fx, "Create zsm file:\n");
	FP(fx, "dz80 a.bin -z\n");
	FP(fx, "Create zsm file with labels for all jumps:\n");
	FP(fx, "dz80 a.bin -z -l\n");
	FP(fx, "Create zsm file with labels for all jumps and addresses as comments:\n");
	FP(fx, "dz80 a.bin -z -l -a\n");
	FP(fx, "Create zsm file with labels for all jumps and addresses as comments, asks for different start address:\n");
	FP(fx, "dz80 a.bin -z -a -l -o\n");
	FP(fx, "Create zsm file with labels for all jumps and source in hex as comments:\n");
	FP(fx, "dz80 a.bin -z -l -t\n");
	exit(1);
	}
for(i=2;i<argc;i++)
	{
	if(argv[i][0]== '-')
		{
		if(argv[i][1]== 'a')aflag=1;
		if(argv[i][1]== 't')tflag=1;
		if(argv[i][1]== 's')sflag=1;
		if(argv[i][1]== 'z')zflag=1;
		if(argv[i][1]== 'r')rflag=1;
		if(argv[i][1]== 'l')lflag=1;
		if(argv[i][1]== 'o')oflag=1;
		}
	}
strcpy(tg,argv[1]);
f1=fopen(tg,"rb");
if(f1==0)
	{
	FP(fx,"Cannot open %s\n",tg);
	exit(1);
	}
i=0;
while(1)
	{
	if(tg[i]=='.')break;
	ts[i]=tg[i];
	tz[i]=tg[i];
	if(tg[i]==0)break;
	i++;
	}
if(sflag)
	{
	strcat(ts,".sym");
	f2=fopen(ts,"w");	/*symbol file*/
	if(f2==0)
		{
		FP(fx,"Cannot create %s\n",ts);
		exit(1);
		}
	}
if(zflag)
	{
	strcat(tz,".zsm");
	f3=fopen(tz,"w");	/*zsm file*/
	if(f3==0)
		{
		FP(fx,"Cannot create %s\n",tz);
		exit(1);
		}
	}
if(oflag)
	{
	FP(fx,"start addres (dec) ? ");
	scanf("%u",&start);
	}
else start=256;/*default cp/m*/
pc=start;
FP(fx,"\n\n");
FP(fx,";%s\n",tg);
FP(fx,"\torg 0%04xh\n\n",pc);

for(i=0;i<6;i++)shiftin();/*t[i]=getc(f1);*/
if(t[0]==-1)exit(1);/*early eof*/

/**************************pass 1*******************************/
/*In pass 1 addresses are calculated, arguments are stored in table*/
FP(fx,"Starting pass 1\n");
pass=1;
while((pci=diz80())!=0)
	{
	FP(fx,"\t\t;%04x",pc);
	FP(fx,"\n");
	if(tosymtab(t,rflag,pc)==0)
		{
		FP(fx,"Symbol table overflow\nAborting\n");
		exit(1);
		}
	for(i=0;i<pci;i++)shiftin();
	pc+=pci;
	end=pc;
	}
fclose(f1);
/******************************pass 2******************************/
/*
In pass 2 a check is made if all arguments stored in the table 
that are within code area range correspond to instruction addresses.
If they do not correspond, they must be changed to the instruction address
just before that + offset (could be self modifiing code)
*/
FP(fx ,"Starting pass 2\n");
pass=2;
f1=fopen(tg,"rb");
	if(f1==0)
		{
		FP(fx,"Cannot open %s\n",tg);
		exit(1);
		}
for(i=0;i<6;i++)shiftin();
pc=start;
while(1)
	{
	sprintf(astr,"%04x",pc);
	putmark(astr);/*mark table entry "used as address"*/
	if((pci=diz80())==0)break;
	FP(fx,"\n");
	for(i=0;i<pci;i++)shiftin();
	pc+=pci;
	}/*end while pass 2*/
fclose(f1);
if(sflag)
	{
	FP(fx,"Making symbol file\n");
	prilist(f2,pc);
	fclose(f2);
	}
else prilist(fx,pc);/*console*/
/***************************pass 3*********************************/
/*
In pass 3 the instruction length is again calculated, the instruction
start addresses are calculated, these are looked up in the table to see if
they correspond to any argument, if they correspond a label is printed
before the instruction, made of lxxx where xxx is the hex address of the
instruction.
*/
FP(fx,"Starting pass 3\n");
if(zflag)FP(fx,"Making zsm file\n");
pass=3;
f1=fopen(tg,"rb");
	if(f1==0)
		{
		FP(fx,"Cannot open %s\n",tg);
		exit(1);
		}
for(i=0;i<6;i++)shiftin();
pc=start;
if(zflag)fx=f3;/*if zsm file requested, all output to .zsm file, else console*/
FP(fx,"\n\torg\t0%04xh\n\n",pc);
while(1)
	{
	sprintf(astr,"%04x",pc);
	if(lookup(astr)!=0)
		{
		FP(fx,"l%04xh:\n",pc);
		}

	if((pci=diz80())==0)break;

	if(aflag||tflag)
		{
		FP(fx,"\t\t;%04x",pc);
		}
	if(tflag)
		{
		FP(fx,"\t");
		for(i=0;i<pci;i++)
			{
			FP(fx,"%02x ",t[i]);
			}
		FP(fx,"\t");
		for(i=0;i<pci;i++)
			{
			if((t[i] >= 32) && (t[i] < 128))FP(fx,"%c ",t[i]);
			else FP(fx,"  ");
			}
		}/*end if tflag*/
	for(i=0;i<pci;i++)shiftin();
	FP(fx,"\n");
	pc+=pci;
	}/*end while pass 3*/
fclose(f1);
//FP(fx,"\n\tend\n");
fx=stdout;/*select console if not already*/
FP(fx,"Ready\n");
if(z80flag)FP(fx,"Code might not be 8080!\n");
if(smcflag)FP(fx,"Self modifiing code detected!\n");
if(zflag)fclose(f3);
exit(0);
}/*end main*/

